/*****
* #ident "%Z%%Y% %M% %I%     %E%
*
* Last Modified %D%
* Module : AC_Info.java
*
* Copyright(c) 2005		Pioneer-soft LLC	All Rights Reserved.
*
*                       "PATENT PENDING"
* This software code is the proprietary of Pioneer-soft, LLC
* You shall use it only in accordance with the terms of the
* license agreement you entered with Pionner-soft, LLC.
*
* Terms Of Use:
* =============
*       This Class code is Open for inspection and may be used
*       only for learning the technology or for educational
*       purpose for limited time, no more than 6 weeks.
*
*       One must obtain a valid licence "Key" and an agreement
*       from Pioneer-soft LLC to use this Code or to build any
*       software based on the "patent-pending" technologies.
*
*
* Description :		A General Utility
*
* Version     : 	1.0
*
* History:	9-9-2005		Raju Chiluvuri		Created New.
*****/
package com.agile.libtemplate;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class AC_Info
{
	public		static		AppConfigInfo	AppCfg	= new AppConfigInfo();

	public		HttpServletRequest	AC_req = null;
	public		ServletContext		ServCntxt = null;

	public		Object		AppResources	= null;
	public		Object		AppData			= null;
	public		Object		UserData		= null;

	public		UniqStrId	unq_str	= 	new UniqStrId();


	// This fields may be used to generate the code in CodeBehind
	// files for Microsoft's XAML prefered style of coding.
	// Also, some SVG developers may prefer CodeBehind style.
	public		String		CodeBehindFile	= null;
	public		PrintWriter CodeB_PW_Out	= null;

	// Nemaes of the Global service functions and Objects.
	public		static	String		OnloadFunc			= "onload_init_list";
	public		static	String		ServicesDirectory	= "service_register_obj";
	public				String		SubWindowOnloadFunc	= null; // E.g.Sub-SVG-Tag

 	private		StringBuffer js_class_list = new StringBuffer(256);
	private 	String	ReqHeader = null;
	private 	String	client_type = null;
	private		String	client_ver = null;

/**	Disable Default Constructor		**/
	private AC_Info () { /* No default constructor. */ }

/**	Constructor		**/
	public AC_Info(HttpServletRequest Req,ServletContext Contxt)	{
		AC_req		=	Req;
		ServCntxt	=	Contxt;
	}

/**	Constructor		**/
	public AC_Info(HttpServletRequest Req,ServletContext Contxt, Object User, Object App)	{
		AC_req		=	Req;
		ServCntxt	=	Contxt;
		UserData	=	User;
		AppData		=	App;
	}

/** Returns the next unique string for the page.	**/
	public	String	getUniqString() {
		return(unq_str.get_uniq_idx());
	}

/*	    Adds the new Java Script class name to the Buffers.
**	    If it is already added before, it just returns TRUE.
** If it returns TRUE, the CLASS-definition code is already in the
** web page, hence, CCG do not need to include the CLASS-definition
** code again in the web document. **/
	public  boolean setJScriptClass (String js_class) {
		if(js_class_list.indexOf(js_class) > 0)		return(true);
		js_class_list.append(" " + js_class);
		return(false);
	}

/** Returns the current ServletContext		***/
	public ServletContext getServletContext()	{
		return ServCntxt;
	}

/** Returns the current HttpServletRequest		***/
	public HttpServletRequest getRequestObject()	{
		return AC_req;
	}

/**	gets FilePath for root directory of the application on the given web server	***/
	public String getRealPath()	{
		return ServCntxt.getRealPath("/");
	}

/** gets FilePath for given relative path on the given web server **/
	public String getRealPath(String path)	{
		return ServCntxt.getRealPath(path);
	}

/** returns true, if the browser is IE **/
	public boolean isIE() {
		if(ReqHeader == null) ReqHeader = AC_req.getHeader("User-Agent");
		return (ReqHeader.indexOf("MSIE") >= 0);
	}
/** returns true, if the browser is Netscape  **/
	public boolean isNS() {
		if(ReqHeader == null) ReqHeader = AC_req.getHeader("User-Agent");
		return (ReqHeader.indexOf("Netscape") >= 0);
	}
/** returns true, if the browser is Mozilla  **/
	public boolean isMozilla() {
		if(ReqHeader == null) ReqHeader = AC_req.getHeader("User-Agent");
		return (ReqHeader.indexOf("Mozilla") >= 0);
	}

/** gets client_type of the client    **/
	public String getClientType()  {
		if(ReqHeader == null) ReqHeader = AC_req.getHeader("User-Agent");

		if(ReqHeader.indexOf("MSIE") >= 0)		client_type="MSIE";
		if(ReqHeader.indexOf("Netscape") >= 0)	client_type="Netscape";
		if(ReqHeader.indexOf("Mozilla") >= 0)	client_type="Mozilla";

		if(client_type == null)		client_type = "UnKnown";
		return client_type;
	}

  	public void setCodeBehindFile(String filename) {
		if(filename == null )	return;
		try {

			if(CodeB_PW_Out != null) {
	 			CodeB_PW_Out.flush();
	 			CodeB_PW_Out.close();
	 			CodeB_PW_Out = null;
			}

			CodeBehindFile = filename;
			FileWriter 	f_wtr = new FileWriter(filename);
			CodeB_PW_Out =	new PrintWriter(f_wtr);
		}

		catch(Exception excp) {
			excp.printStackTrace();
		}
		return;
	}
}