// Copyright(c) 2004 All Rights Reserved...Raju Chiluvuri
/*****
**                       "PATENT PENDING"
** This code must be treated as an example pseudo code. This is
** just an example to teach the special methods of the CCG. This
** is intended for showing some new features. This code is not
** intended for use in any application (nor error free). However,
** useful to build example web pages to learn the patent methods
*****/
package com.agile.libtemplate;

import java.io.*;
import java.util.*;
import javax.servlet.http.HttpServletRequest;

public class ATC_CF extends AgileTemplate	{
	String	City_code = null;
	String	set_update_timer = null;

	String	Flight_data_url = null;
	AC_Info aci=null;

	// Constructor, which also initializes the Object.
	public ATC_CF (AC_Info ACI, String code, String data_url)	{
		super(ACI);
		aci=ACI;
		City_code = code;
		Flight_data_url = data_url;
	}
	// Constructor, which also initializes the Object.
	public ATC_CF (AC_Info ACI, String code, String data_url, String timer_func)	{
		super(ACI);
		aci=ACI;
		City_code = code;
		Flight_data_url = data_url;
		set_update_timer = timer_func;
	}


    // The Code Generation Method : CGM
    public int CGM (PrintWriter out){

// If I am not lazy and I have data, I would write the Application logic
// to get the data for each of the Flight in the Air space of the city.
// To test the CF: This now supports only 3 cities & uses static data,

		if (City_code.equalsIgnoreCase("JFK")) {
				JFK_air_trafic(out);
		}
		else  if (City_code.equalsIgnoreCase("LAX")) {
				LAX_air_trafic(out);
		}
		else  if(City_code.equalsIgnoreCase("DTW")) {
			det_air_trafic(out);
		}
		else if(City_code.equalsIgnoreCase("ORD")) {
			ord_air_trafic(out);
		}
		else{
			sfo_air_trafic(out);
		}


// In the real application the CF could access the City-airport database
// and creates the ATC map for the given City. However, in this sample
// CCG, we are using static data to display the flights.
		return(0);
    }	// END of the CGM()

public String getName_RemoveBackground() {
	return("remove_background" + UNQ_ID +"");
}

int JFK_air_trafic(PrintWriter out) {

// This instantiates and initializes the Airplane-component.
// To test, I am using static data.
// But, one could access the data to create a list of flights
// in the Air space, then write a for loop and create Airline
// component for each flight in the Air space of the city.

	set_bg_image(out);

	Airplane Al1 = new Airplane(aci,"TWA486","B737", 1, Flight_data_url);
	Al1.setCallBackName("flight_info_table.Display_info");
	Al1.set_location (90, 50, -40);
	Al1.setSmallMessages("LAX-to-JFK", "Radio Ch#36");
	Al1.CGM(out);
	if (set_update_timer != null)
		out.println("<script> " + set_update_timer + "( " + Al1.getAC_ObjectName() + ".ajax_update_loc) </script>");


	Airplane Al2 = new Airplane(aci, "AA486","SF37", 2, Flight_data_url);
	Al2.set_location (360, 180, 20);
	Al2.setCallBackName("flight_info_table.Display_info");
	Al2.setSmallMessages("SFO-to-LAX", "Radio Ch#27");
	Al2.CGM(out);
	if (set_update_timer != null)
		out.println("<script> " + set_update_timer + "( " + Al2.getAC_ObjectName() + ".ajax_update_loc) </script>");


	Airplane Al3 = new Airplane(aci, "UA486","DC10", 4, Flight_data_url);
	Al3.set_location (400, 400, 45);
	Al3.setCallBackName("flight_info_table.Display_info");
	Al3.setSmallMessages("SFO-to-DFW", "Radio Ch#18");
	Al3.CGM(out);
	if (set_update_timer != null)
		out.println("<script> " + set_update_timer + "( " + Al3.getAC_ObjectName() + ".ajax_update_loc) </script>");



	Airplane Al4 = new Airplane(aci, "NW63","A330", 3, Flight_data_url);
	Al4.set_location (140, 225, 180);
	Al4.setCallBackName("flight_info_table.Display_info");
	Al4.setSmallMessages("LAG-to-SFO", "Radio Ch#45");
	Al4.CGM(out);
	if (set_update_timer != null)
		out.println("<script> " + set_update_timer + "( " + Al4.getAC_ObjectName() + ".ajax_update_loc) </script>");



	Airplane Al5 = new Airplane(aci, "SW36","B747", 4, Flight_data_url);
	Al5.set_location (360, 320, -120);
	Al5.setCallBackName("flight_info_table.Display_info");
	Al5.setSmallMessages("ATL-to-SFO", "Radio Ch#27");
	Al5.CGM(out);
	if (set_update_timer != null)
		out.println("<script> " + set_update_timer + "( " + Al5.getAC_ObjectName() + ".ajax_update_loc) </script>");



	Airplane Al6 = new Airplane(aci, "DEL36","B340", 0, Flight_data_url);
	Al6.set_location (63, 380, -80);
	Al6.setCallBackName("flight_info_table.Display_info");
	Al6.setSmallMessages("DUL-to-SFO", "Radio Ch#43");
	Al6.CGM(out);
	if (set_update_timer != null)
		out.println("<script> " + set_update_timer + "( " + Al6.getAC_ObjectName() + ".ajax_update_loc) </script>");


	return(0);

	}


int LAX_air_trafic(PrintWriter out) {

	set_bg_image(out);

	Airplane Al2 = new Airplane(aci, "AA486","SF37", 2, Flight_data_url);
	Al2.set_location (300, 80, 200);
	Al2.setCallBackName("flight_info_table.Display_info");
	Al2.setSmallMessages("SFO-to-LAX", "Radio Ch#27");
	Al2.CGM(out);
	if (set_update_timer != null)
		out.println("<script> " + set_update_timer + "( " + Al2.getAC_ObjectName() + ".ajax_update_loc) </script>");


	Airplane Al3 = new Airplane(aci, "UA486","DC10", 4, Flight_data_url);
	Al3.set_location (390, 256, 86);
	Al3.setCallBackName("flight_info_table.Display_info");
	Al3.setSmallMessages("SFO-to-DFW", "Radio Ch#18");
	Al3.CGM(out);
	if (set_update_timer != null)
		out.println("<script> " + set_update_timer + "( " + Al3.getAC_ObjectName() + ".ajax_update_loc) </script>");


	Airplane Al4 = new Airplane(aci, "NW63","A330", 3, Flight_data_url);
	Al4.set_location (130, 200, 80);
	Al4.setCallBackName("flight_info_table.Display_info");
	Al4.setSmallMessages("LAG-to-SFO", "Radio Ch#45");
	Al4.CGM(out);
	if (set_update_timer != null)
		out.println("<script> " + set_update_timer + "( " + Al4.getAC_ObjectName() + ".ajax_update_loc) </script>");


	Airplane Al5 = new Airplane(aci, "SW36","B747", 6, Flight_data_url);
	Al5.set_location (260, 200, 120);
	Al5.setCallBackName("flight_info_table.Display_info");
	Al5.setSmallMessages("ATL-to-SFO", "Radio Ch#27");
	Al5.CGM(out);
	if (set_update_timer != null)
		out.println("<script> " + set_update_timer + "( " + Al5.getAC_ObjectName() + ".ajax_update_loc) </script>");



	Airplane Al6 = new Airplane(aci, "DEL36","B340", 0, Flight_data_url);
	Al6.set_location (456, 353, 67);
	Al6.setCallBackName("flight_info_table.Display_info");
	Al6.setSmallMessages("DUL-to-SFO", "Radio Ch#43");
	Al6.CGM(out);
	if (set_update_timer != null)
		out.println("<script> " + set_update_timer + "( " + Al6.getAC_ObjectName() + ".ajax_update_loc) </script>");


	return(0);

	}
int sfo_air_trafic(PrintWriter out) {

	set_bg_image(out);

	Airplane Al1 = new Airplane(aci, "TWA486","B737", 1, Flight_data_url);
	Al1.setCallBackName("flight_info_table.Display_info");
	Al1.set_location (190, 150, 40);
	Al1.setSmallMessages("LAX-to-JFK", "Radio Ch#36");
	Al1.CGM(out);
	if (set_update_timer != null)
		out.println("<script> " + set_update_timer + "( " + Al1.getAC_ObjectName() + ".ajax_update_loc) </script>");


	Airplane Al2 = new Airplane(aci, "AA486","SF37", 2, Flight_data_url);
	Al2.set_location (360, 180, -20);
	Al2.setCallBackName("flight_info_table.Display_info");
	Al2.setSmallMessages("SFO-to-LAX", "Radio Ch#27");
	Al2.CGM(out);
	if (set_update_timer != null)
		out.println("<script> " + set_update_timer + "( " + Al2.getAC_ObjectName() + ".ajax_update_loc) </script>");


	Airplane Al3 = new Airplane(aci, "UA486","DC10", 4, Flight_data_url);
	Al3.set_location (400, 350, -45);
	Al3.setCallBackName("flight_info_table.Display_info");
	Al3.setSmallMessages("SFO-to-DFW", "Radio Ch#18");
	Al3.CGM(out);
	if (set_update_timer != null)
		out.println("<script> " + set_update_timer + "( " + Al3.getAC_ObjectName() + ".ajax_update_loc) </script>");


	Airplane Al4 = new Airplane(aci, "NW63","A330", 3, Flight_data_url);
	Al4.set_location (270, 425, 80);
	Al4.setCallBackName("flight_info_table.Display_info");
	Al4.setSmallMessages("LAG-to-SFO", "Radio Ch#45");
	Al4.CGM(out);
	if (set_update_timer != null)
		out.println("<script> " + set_update_timer + "( " + Al4.getAC_ObjectName() + ".ajax_update_loc) </script>");




	return(0);

	}


int det_air_trafic(PrintWriter out) {

// This instantiates and initializes the Airplane-component.
// To test, I am using static data.
// But, one could access the data to create a list of flights
// in the Air space, then write a for loop and create Airline
// component for each flight in the Air space of the city.

	set_bg_image(out);

	Airplane Al1 = new Airplane(aci,"TWA486","B737", 1, Flight_data_url);
	Al1.setCallBackName("flight_info_table.Display_info");
	Al1.set_location (240, 50, -40);
	Al1.setSmallMessages("LAX-to-JFK", "Radio Ch#36");
	Al1.CGM(out);
	if (set_update_timer != null)
			out.println("<script> " + set_update_timer + "( " + Al1.getAC_ObjectName() + ".ajax_update_loc) </script>");


	Airplane Al2 = new Airplane(aci, "AA486","SF37", 2, Flight_data_url);
	Al2.set_location (345, 180, 20);
	Al2.setCallBackName("flight_info_table.Display_info");
	Al2.setSmallMessages("SFO-to-LAX", "Radio Ch#27");
	Al2.CGM(out);
	if (set_update_timer != null)
			out.println("<script> " + set_update_timer + "( " + Al2.getAC_ObjectName() + ".ajax_update_loc) </script>");

	Airplane Al3 = new Airplane(aci, "UA486","DC10", 4, Flight_data_url);
	Al3.set_location (111, 400, 45);
	Al3.setCallBackName("flight_info_table.Display_info");
	Al3.setSmallMessages("SFO-to-DFW", "Radio Ch#18");
	Al3.CGM(out);
	if (set_update_timer != null)
			out.println("<script> " + set_update_timer + "( " + Al3.getAC_ObjectName() + ".ajax_update_loc) </script>");

	Airplane Al4 = new Airplane(aci, "NW63","A330", 3, Flight_data_url);
	Al4.set_location (234, 225, 180);
	Al4.setCallBackName("flight_info_table.Display_info");
	Al4.setSmallMessages("LAG-to-SFO", "Radio Ch#45");
	Al4.CGM(out);
	if (set_update_timer != null)
			out.println("<script> " + set_update_timer + "( " + Al4.getAC_ObjectName() + ".ajax_update_loc) </script>");

	return(0);

	}

int ord_air_trafic(PrintWriter out) {

// This instantiates and initializes the Airplane-component.
// To test, I am using static data.
// But, one could access the data to create a list of flights
// in the Air space, then write a for loop and create Airline
// component for each flight in the Air space of the city.

	set_bg_image(out);

	Airplane Al1 = new Airplane(aci,"TWA486","B737", 1, Flight_data_url);
	Al1.setCallBackName("flight_info_table.Display_info");
	Al1.set_location (234, 50, -40);
	Al1.setSmallMessages("LAX-to-JFK", "Radio Ch#36");
	Al1.CGM(out);
	if (set_update_timer != null)
			out.println("<script> " + set_update_timer + "( " + Al1.getAC_ObjectName() + ".ajax_update_loc) </script>");

	Airplane Al2 = new Airplane(aci, "AA486","SF37", 2, Flight_data_url);
	Al2.set_location (657, 180, 20);
	Al2.setCallBackName("flight_info_table.Display_info");
	Al2.setSmallMessages("SFO-to-LAX", "Radio Ch#27");
	Al2.CGM(out);
	if (set_update_timer != null)
			out.println("<script> " + set_update_timer + "( " + Al2.getAC_ObjectName() + ".ajax_update_loc) </script>");

	Airplane Al3 = new Airplane(aci, "UA486","DC10", 4, Flight_data_url);
	Al3.set_location (255, 400, 45);
	Al3.setCallBackName("flight_info_table.Display_info");
	Al3.setSmallMessages("SFO-to-DFW", "Radio Ch#18");
	Al3.CGM(out);
	if (set_update_timer != null)
			out.println("<script> " + set_update_timer + "( " + Al3.getAC_ObjectName() + ".ajax_update_loc) </script>");

	Airplane Al4 = new Airplane(aci, "NW63","A330", 3, Flight_data_url);
	Al4.set_location (126, 700, 180);
	Al4.setCallBackName("flight_info_table.Display_info");
	Al4.setSmallMessages("LAG-to-SFO", "Radio Ch#45");
	Al4.CGM(out);
	if (set_update_timer != null)
			out.println("<script> " + set_update_timer + "( " + Al4.getAC_ObjectName() + ".ajax_update_loc) </script>");


	Airplane Al5 = new Airplane(aci,"SW36","MD11",4,"get_info.jsp");
	Al5.set_location(360, 320, -120);
	Al5.setCallBackName("flight_info_table.Display_info");
	Al5.setSmallMessages("IAD-to-SFO", "Radio Ch#27");
	Al5.CGM(out);
	if (set_update_timer != null)
			out.println("<script> " + set_update_timer + "( " + Al5.getAC_ObjectName() + ".ajax_update_loc) </script>");


	Airplane Al6 = new Airplane(aci,"DEL36","B340", 3, "get_info.jsp");
	Al6.set_location (63, 380, -80);
	Al6.setCallBackName("flight_info_table.Display_info");
	Al6.setSmallMessages("DUL-to-SFO", "Radio Ch#43");
	Al6.CGM(out);
	if (set_update_timer != null)
			out.println("<script> " + set_update_timer + "( " + Al6.getAC_ObjectName() + ".ajax_update_loc) </script>");



	Airplane Al7 = new Airplane(aci,"UA7346","A330", 1, "get_info.jsp");
	Al7.set_location (50, 280, -10);
	Al7.setCallBackName("flight_info_table.Display_info");
	Al7.setSmallMessages("ORD-to-JFK", "Radio Ch#49");
	Al7.CGM(out);
	if (set_update_timer != null)
			out.println("<script> " + set_update_timer + "( " + Al7.getAC_ObjectName() + ".ajax_update_loc) </script>");


	Airplane Al8 = new Airplane(aci,"AI126","B737", 2, "get_info.jsp");
	Al8.set_location (100, 500, -90);
	Al8.setCallBackName("flight_info_table.Display_info");
	Al8.setSmallMessages("ORD-to-LHR", "Radio Ch#50");
	Al8.CGM(out);
	if (set_update_timer != null)
			out.println("<script> " + set_update_timer + "( " + Al8.getAC_ObjectName() + ".ajax_update_loc) </script>");


	Airplane Al9 = new Airplane(aci,"LH4237","A330", 3, "get_info.jsp");
	Al9.set_location (490, 500, -39);
	Al9.setCallBackName("flight_info_table.Display_info");
	Al9.setSmallMessages("CDG-to-ORD", "Radio Ch#24");
	Al9.CGM(out);
	if (set_update_timer != null)
			out.println("<script> " + set_update_timer + "( " + Al9.getAC_ObjectName() + ".ajax_update_loc) </script>");

	Airplane Al10 = new Airplane(aci,"AA293","MD11", 1, "get_info.jsp");
	Al10.set_location (426,100, -99);
	Al10.setCallBackName("flight_info_table.Display_info");
	Al10.setSmallMessages("DEL-to-DTW", "Radio Ch#25");
	Al10.CGM(out);
	if (set_update_timer != null)
			out.println("<script> " + set_update_timer + "( " + Al10.getAC_ObjectName() + ".ajax_update_loc) </script>");



	Airplane Al11 = new Airplane(aci,"OZ602","A330", 2, "get_info.jsp");
	Al11.set_location (245,190, -45);
	Al11.setCallBackName("flight_info_table.Display_info");
	Al11.setSmallMessages("SYD-to-DTW", "Radio Ch#26");
	Al11.CGM(out);
	if (set_update_timer != null)
			out.println("<script> " + set_update_timer + "( " + Al11.getAC_ObjectName() + ".ajax_update_loc) </script>");


	Airplane Al12 = new Airplane(aci,"DL5220","SF37", 4, "get_info.jsp");
	Al12.set_location (678,100, -78);
	Al12.setCallBackName("flight_info_table.Display_info");
	Al12.setSmallMessages("JFK-to-DTW", "Radio Ch#27");
	Al12.CGM(out);
	if (set_update_timer != null)
			out.println("<script> " + set_update_timer + "( " + Al12.getAC_ObjectName() + ".ajax_update_loc) </script>");


	Airplane Al13 = new Airplane(aci,"US6406","SF37", 0, "get_info.jsp");
	Al13.set_location (700,36, 50);
	Al13.setCallBackName("flight_info_table.Display_info");
	Al13.setSmallMessages("DTW-to-ORD", "Radio Ch#28");
	Al13.CGM(out);
	if (set_update_timer != null)
			out.println("<script> " + set_update_timer + "( " + Al13.getAC_ObjectName() + ".ajax_update_loc) </script>");


	Airplane Al14 = new Airplane(aci,"CO1027","B737", 1, "get_info.jsp");
	Al14.set_location (200,50, 20);
	Al14.setCallBackName("flight_info_table.Display_info");
	Al14.setSmallMessages("NRT-to-JFK", "Radio Ch#90");
	Al14.CGM(out);
	if (set_update_timer != null)
			out.println("<script> " + set_update_timer + "( " + Al14.getAC_ObjectName() + ".ajax_update_loc) </script>");

	Airplane Al15 = new Airplane(aci,"NW8611","MD11", 2, "get_info.jsp");
	Al15.set_location (240,30, 67);
	Al15.setCallBackName("flight_info_table.Display_info");
	Al15.setSmallMessages("AMS-to-ORD", "Radio Ch#34");
	Al15.CGM(out);
	if (set_update_timer != null)
			out.println("<script> " + set_update_timer + "( " + Al15.getAC_ObjectName() + ".ajax_update_loc) </script>");


	Airplane Al16 = new Airplane(aci,"UA1","B340", 3, "get_info.jsp");
	Al16.set_location (290,90, 89);
	Al16.setCallBackName("flight_info_table.Display_info");
	Al16.setSmallMessages("HNL-to-ORD", "Radio Ch#35");
	Al16.CGM(out);
	if (set_update_timer != null)
			out.println("<script> " + set_update_timer + "( " + Al16.getAC_ObjectName() + ".ajax_update_loc) </script>");


	Airplane Al17 = new Airplane(aci,"UA3118","A330", 4, "get_info.jsp");
	Al17.set_location (378,200,100);
	Al17.setCallBackName("flight_info_table.Display_info");
	Al17.setSmallMessages("ORD-to-ACA", "Radio Ch#36");
	Al17.CGM(out);
	if (set_update_timer != null)
			out.println("<script> " + set_update_timer + "( " + Al17.getAC_ObjectName() + ".ajax_update_loc) </script>");


	Airplane Al18 = new Airplane(aci,"NW1251","SF37", 0, "get_info.jsp");
	Al18.set_location (400,129,124);
	Al18.setCallBackName("flight_info_table.Display_info");
	Al18.setSmallMessages("DTW-to-ORD", "Radio Ch#37");
	Al18.CGM(out);
	if (set_update_timer != null)
			out.println("<script> " + set_update_timer + "( " + Al18.getAC_ObjectName() + ".ajax_update_loc) </script>");


	return(0);

}

	int set_bg_image (PrintWriter out) {
		out.println(" <script type='text/ecmascript'> ");
		out.println(" var bg_state" + UNQ_ID +" = 0; ");
		out.println("     function set_background" + UNQ_ID +"() { ");
		out.println("     	if(bg_state" + UNQ_ID +" == 1)	bg_state" + UNQ_ID +" = 0; ");
		out.println("     	else			bg_state" + UNQ_ID +" = 1; ");
		//out.println(" alert ('BG-info: " + City_code + " = ' + bg_state" + UNQ_ID +" + ';');");
		out.println(" 	var svgobj = SVG_Document.getElementById('city_background" + UNQ_ID +"'); ");
		out.println(" 	(svgobj.getStyle()).setProperty ('visibility', (bg_state" + UNQ_ID +" == 1) ? 'visible' : 'hidden'); ");
		out.println("  ");
		out.println("     } ");

		out.println("     function remove_background" + UNQ_ID +"() { ");
		out.println("     	bg_state" + UNQ_ID +" = 0; ");
		out.println(" 	var svgobj = SVG_Document.getElementById('city_background" + UNQ_ID +"'); ");
		out.println(" 	(svgobj.getStyle()).setProperty ('visibility','hidden'); ");
		out.println("  ");
		out.println("     } ");
		out.println(" </script> ");

		out.println(" <rect style='fill:white;stroke:black;' x='5' y='5' width='700' height='500'/> ");
		out.println(" <g id='city_background" + UNQ_ID +"' style='visibility:hidden;opacity:0.5;'> ");
		out.println(" <image xlink:href='App1/" + City_code + ".GIF' x='5' y='5' width='700' height='500' /> ");
		out.println(" </g> ");
		out.println(" <g transform='translate(180 520)' onclick='set_background" + UNQ_ID +"()'> ");
		out.println("     <rect style='fill:tan;stroke:black;' x='0' y='0' width='20' height='20'/> ");
		out.println("     <text style='fill:black;font-size:14pt' x='25' y='18'> Show/Hide " + City_code + " Background</text> ");
		out.println(" </g> ");
		out.println(" <!-- End of the Code for the Designated Utility Component. --> ");
		out.println(" <script xlink:href='App1/Webservices_class.js' language='text/ecmascript' /> ");

		return(0);
	}

}	// END of the Class Definition.