/*****
* #ident "%Z%%Y% %M% %I%     %E%
*
* Last Modified %D%
* Module : AgileTemplate.java
*
* Copyright(c) 2005		Pioneer-soft LLC	All Rights Reserved.
*
*                       "PATENT PENDING"
* This software code is the proprietary of Pioneer-soft, LLC
* You shall use it only in accordance with the terms of the
* license agreement you entered with Pionner-soft, LLC.
*
* Terms Of Use:
* =============
*       This Class code is Open for inspection and may be used
*       only for learning the technology or for educational
*       purpose for limited time, no more than 6 weeks.
*
*       One must obtain a valid licence "Key" and an agreement
*       from Pioneer-soft LLC to use this Code or to build any
*       software based on the "patent-pending" technologies.
*
*
* Description	:		The base class for the GUI classes/CF
*
* Version		:		1.0
*
* History		:		9-9-2005	Raju Chiluvuri		Created New.
*****/
package com.agile.libtemplate;

import java.io.*;
import java.util.*;
import javax.servlet.http.HttpServletRequest;

public abstract class AgileTemplate		{

	public	String		UNQ_ID	= null;
	public	AC_Info		aci		= null;

	public	int		x_loc	= 0;
	public	int		y_loc 	= 0;
	public	int		width	= -1;
	public	int		hight	= -1;

	// This fields may be used to generate the code in CodeBehind
	// files for Microsoft's XAML prefered style of coding.
	// public		String		CodeBehindFile	= null;
	// public		PrintWriter CodeB_PW_Out	= null;

	public AgileTemplate (AC_Info ACin) {
		aci = ACin;
		UNQ_ID = aci.getUniqString();
	}

	public AgileTemplate (AC_Info ACin, int x, int y, int wid, int ht) {
		aci = ACin;
		UNQ_ID = aci.getUniqString();
		x_loc = x;
		y_loc = y;
		width = wid;
		hight = ht;
	}
	private AgileTemplate () {
		// No default constructor.
		// The derived classes should use: super(ACinfo);
	}

	public void	  setAC_UniqId (String new_index)	{	UNQ_ID = new_index; }
	public void	  ResetAC_UniqId ()					{	UNQ_ID = aci.getUniqString(); }
	public void	  appendAC_Index (String new_index)	{	UNQ_ID = UNQ_ID + new_index; }
	public String getUniqueId() { return(UNQ_ID); }

/*** The main Abstract function. ***/
	public abstract int CGM (PrintWriter out);

	public String toString()	{
		StringWriter	sw = new StringWriter();
		PrintWriter		pw = new PrintWriter(sw);
		CGM(pw);
		return(sw.toString());
  	}

	public int GenerateComponentCode(Object accg, PrintWriter out) {
	int status = 0;

		if(accg instanceof AgileTemplate)
			status = ((AgileTemplate)accg).CGM(out);
		//  else
	    // 	if(accg instanceof V1Template)
		//		status = ((V1Template)accg).V1CGM(out, doc_info);
		//  else
	    // 	if(accg instanceof V2Template)
		//		status = ((V2Template)accg).V2CGM(out, doc_info);
		else
				out.print(accg);
		return(status);
	}

  	public void test_build_AC(String filename) {

		if(filename == null )	return;

		// This will be a useful function to test each AC seperatly.
		// This writes the AC and other necesary  code to the file.
		try {
			FileWriter 	f_wtr = new FileWriter(filename);
			PrintWriter f_out =	new PrintWriter(f_wtr);

			aci.AppCfg.HeaderCode(f_out);
	 		CGM(f_out);
	 		aci.AppCfg.TrailerCode(f_out);
	 		f_out.flush();
	 		f_out.close();
		}

		catch(Exception excp) {
			excp.printStackTrace();
		}
		return;
	}
	/*********************************************************
	** Certain implementation may define the followingfunctions
	**********************************************************/
	// This method may be called to get the service method name
	// of the AC. If the AC supports more than one service, it
	// uses the Service_name to return the service method
	public String getServiceMethodByName(String Service_name) {
		return (null);
	}

	// This method may be called to get the name of the Service Method
	// in the AC. One could use the JScript function name to generate
	// integration code, to register a Callback for the event.
	public String getEventNotifyRegistrationMethod(String event_name) {
		return (null);
	}

	// This method may be used to register a Function for a given event.
	// The CCG would generate the necesary code in the AC, so that the
	// AC calls the callback cb_func, upon the given event.
	public boolean setEventCallback(String event_name, String cb_func){
		return (false);
	}

	/*********************************************************
	** An Alternative implementation may define the following
	** abstract functions.
	**********************************************************
	//This Method may be called to find the Class of INPUT CCG
	//Object. This may be used by ICCG to validate the class.
	//Ex: If the CCG is Show-layer, it may return "SHOW_LAYER"
	public abstract String getCCG_ClassName();

	//This Method may be called to get the name of Primary
	//Service Method of the subcomponent. If the CCG-Class
	//does not support any service method, this function
	//causes error. Caller might validate the Class Name
	//before calling this method for Integration Data.
	public abstract String getPrimaryServiceMethodName();

	//This Method may be called to get the name of Primary
	//Service Method of the subcomponent, to Set a Callback.
	//If the CCG-Class does not support any service method,
	//this function returns error (or may throw an exception).
	public abstract String getPrimaryCallbackRegisterName();
	*********************************************************/
}