/*****
* #ident "%Z%%Y% %M% %I%     %E%
*
* Last Modified %D%
* Module : AppConfigInfo.java
*
* Copyright(c) 2005		Pioneer-soft LLC	All Rights Reserved.
*
*                       "PATENT PENDING"
* This software code is the proprietary of Pioneer-soft, LLC
* You shall use it only in accordance with the terms of the
* license agreement you entered with Pionner-soft, LLC.
*
* Terms Of Use:
* =============
*       This Class code is Open for inspection and may be used
*       only for learning the technology or for educational
*       purpose for limited time, no more than 6 weeks.
*
*       One must obtain a valid licence "Key" and an agreement
*       from Pioneer-soft LLC to use this Code or to build any
*       software based on the "patent-pending" technologies.
*
*
* Description:	A General Utility to get paths and other data
*
* Version	:	1.0
*
* History	:	9-9-2005	Raju Chiluvuri		Created New.
*****/
package com.agile.libtemplate;

import java.io.*;
import java.util.*;
import javax.servlet.http.HttpServletRequest;

public class AppConfigInfo {

private	static boolean InitAppConfig	= false;    // Is the Application Configuration initialized
private static String ConfigFile		= null;     // The AC/Template Environment config file

public	static String AppRootPath		= null;     // root path

public	static String JscriptFilesPath	= null;     // java script files path
public	static String JarFilesPath		= null;     // jar files path
public	static String ImagePath			= null;     // image files path (gif files)
public	static String FlatFilePath		= null;     // flat file path


private	static	String	PropFilePath	= null;     // Properties file path
public	static	Properties prop			= null;     //Component properties

public	static	short	logLevel		= 0;        // for logging Stream
private	static	String	LogFilePath		= null;     // Log file path

/***	Constructor		***/
public AppConfigInfo()	{
		InitApplicationConfigInfo(null);
	}


public Properties getProperties(String prop_file) {

	try {
		FileInputStream f_in = new FileInputStream(prop_file);

		Properties prop = new Properties();
		prop.load(f_in);
	}

	catch(Exception excp) {
		excp.printStackTrace();
	}
	return(prop);
}

public void	HeaderCode(PrintWriter out) {
	out.println ("<svg width='500' height='500' onload='svg_doc_onload_init(evt)'>");
	out.println ("<script xlink:href='misc_util.js' language='text/ecmascript'/>");
}
public void	TrailerCode(PrintWriter out) {
	out.println ("<script xlink:href='misc_util2.js' language='text/ecmascript'/>\n</svg>");
}

public	void ResetApplicationConfigInfo(String config_file) {
	InitAppConfig = false;
	InitApplicationConfigInfo(config_file);
}

private static void InitApplicationConfigInfo(String config_file) {
String str		= null;
String fname	= null;
FileReader		f_in = null;
BufferedReader	f_buff = null;

	if(InitAppConfig)	return;
	InitAppConfig = true;
	if(InitAppConfig)	return; // Do nor read this file for now

	if (config_file != null)	fname = config_file;
	else {
		fname = System.getenv("AGILE_CONFIG_FILE");
		if(fname == null)	fname = "c:/Program Files/AgileTemplates.ini";
	}

	try {
		f_in = new FileReader(fname);
		f_buff = new BufferedReader(f_in);
	}

	catch(Exception excp) {
		excp.printStackTrace();
	}

	try {
		while((str = f_buff.readLine()) != null) {

			if(str.equals("JSCRIPT_CLASS_FILES_PATH")) {
				str = f_buff.readLine();
				FlatFilePath = str;
			}

			if(str.equals("IMAGES_PATH")) {
				str = f_buff.readLine();
				ImagePath = str;
			}

			if(str.equals("JSCRIPT_FILES_PATH")) {
					str = f_buff.readLine();
					JscriptFilesPath = str;
			}

			if(str.equals("JAR_FILES_PATH")) {
				str = f_buff.readLine();
				JarFilesPath = str;
			}

			if(str.equals("PROPERTY_FILES_PATH")) {
				str = f_buff.readLine();
				PropFilePath = str;
			}
		}
		f_in.close();
	}

	catch(Exception excp) {
		excp.printStackTrace();
	}
}
}// End of the CLASS