// Copyright(c) 2004 All Rights Reserved...Raju Chiluvuri
/*****
**                       "PATENT PENDING"
** This code must be treated as an example pseudo code. This is
** just an example to teach the special methods of the CCG. This
** is intended for showing some new features. This code is not
** intended for use in any application (nor error free). However,
** useful to build example web pages to learn the patent methods
*****/
package com.agile.libtemplate;

import java.io.*;
import java.util.*;
import javax.servlet.http.HttpServletRequest;

public class CheckBoxes extends AgileTemplate	{
	int count = 0;
	int states[] = null;
	String boxes[] = null;
	String Obj_name, callback = null;

	// Constructor, which also initializes the Object.
	public CheckBoxes(AC_Info ACI, String list[], int num)	{
		super(ACI);
		count = num;
		boxes = list;
		states = new int[num];
		Obj_name = "cbox_" + UNQ_ID;
	}
	public void setDefaultStates(int def[])	{
			states = def;
	}

	// This Service Method of the Template returns,
	// The Service Method name of the Presentation-block.
	public String getSetCboxMethodName()	{
		String name = Obj_name + ".set_check_box_state";
		return(name);
	}
	public String getCB_AddMethodName()	{

		String name = Obj_name + ".add_callback";
		return(name);
	}
	public void setCB_AddMethod(String cb_name) {
		callback = cb_name;
	}

	// The Code Generation Method : CGM
	public int CGM (PrintWriter out) {

		// Code Check, if the CLASS definition is already in the Web document.
		if (this.aci.setJScriptClass("check_boxes_v1_0") == false)		{ // Skip the class code
out.println("//SECTION-1:Copyright (C) All Rights reserved...Raju Chiluvuri");
out.println("<script type='text/ecmascript'> ");
out.println("<![CDATA[ ");
out.println("function check_boxes_v1_0(cb_list, state_list) ");
out.println("{ ");
out.println("    this.switch_check_box = switch_check_box; ");
out.println("    this.set_check_box_state = set_check_box_state; ");
out.println("    this.add_callback = add_callback; ");
out.println("    var cb_states = state_list; ");
out.println("    var cbox_list = cb_list; ");
out.println("    var callback_func = null; ");
out.println("    var group_id = 'GROUP_ID'; ");
out.println(" ");
out.println("    function add_callback( grp_id, cb_name ) { ");
out.println("    		group_id = grp_id; ");
out.println("   		callback_func = cb_name; ");
out.println("    } ");
out.println(" ");
out.println("    function switch_check_box(box_id) { ");
out.println(" ");
out.println("    	var svgobj = SVG_Document.getElementById(cbox_list[box_id]); ");
out.println("    	if ( cb_states[box_id] == 0) { ");
out.println("		(svgobj.getStyle()).setProperty ('visibility', 'visible'); ");
out.println("		cb_states[box_id] = 1; ");
out.println("	}  ");
out.println("	else { ");
out.println("		(svgobj.getStyle()).setProperty ('visibility', 'hidden'); ");
out.println("		cb_states[box_id] = 0; ");
out.println("	} ");
out.println("	if (callback_func != null)  ");
out.println("		callback_func(group_id, cb_states[box_id], box_id); ");
out.println("    } ");
out.println("     ");
out.println("    function set_check_box_state(box_id, state) { ");
out.println("	if ( cb_states[box_id] != state ) ");
out.println("		switch_check_box(box_id); ");
out.println("    } ");
out.println("} ");
out.println("]]> ");
out.println("</script> ");
				} // If statement to skip the JScript Class Defenition

out.println(" ");
out.println("// SECTION-2: Instantiation and Init section Radio-button Object ");
out.println("<script type='text/ecmascript'> ");

out.print("var cbox_list_" + UNQ_ID + " = new Array(");
	for (int i = 0; i < count; i++) {
out.print("'cbox_" + i + "_" + UNQ_ID + "'");
		if(i < (count-1))	out.print(",");
	}
out.println("); ");

out.print("var cb_states_" + UNQ_ID + " = new Array(");
	for (int i = 0; i < count; i++) {
		if(states[i] == 0)	out.print("0");
		else			out.print("1");
		if(i < (count-1))	out.print(", ");
	}
out.println("); ");

out.println("var cbox_" + UNQ_ID + " = new check_boxes_v1_0(cbox_list_" + UNQ_ID + ", cb_states_" + UNQ_ID + "); ");
out.println(" ");
	if (callback != null) {
out.println(" // Add code to call the callback. ");
out.println("cbox_" + UNQ_ID + ".add_callback( 'none', " + callback + "); ");
	}
out.println(" ");
out.println("</script> ");
out.println(" ");
out.println("//SECTION-3: Presentation Section for the Rotate-Banner ");
out.println("<g> ");
	for (int i = 0; i < count; i++) {
	int y = i*20 + 5;
out.println("	<g transform='translate(5 " + y + ")' onclick='cbox_" + UNQ_ID + ".switch_check_box(" + i +")'> ");
out.println("		<text x='20' y='20'> " + boxes[i] + "</text> ");
out.println("		<rect x='5' y='10' width='10' height='10' stroke-width='1' stroke='rgb(100,100,100)' fill='white'/> ");
if(states[i]==0)
out.println("		<g transform='translate(5 10)' id='cbox_" + i + "_" + UNQ_ID + "' style='visibility:hidden;'> ");
else{
out.println("		<g transform='translate(5 10)' id='cbox_" + i + "_" + UNQ_ID + "' style='visibility:visible;'> ");
}
out.println("			<line x1='1' y1='1' x2='9' y2='9' stroke='black'/> ");
out.println("			<line x1='1' y1='9' x2='9' y2='1' stroke='black'/> ");
out.println("		</g>");
out.println("	</g>");
	}
out.println("</g> ");
return 0;
	}	// END of the CGM()

}	// END of the Class Definition.