// Copyright(c) 2004 All Rights Reserved...Raju Chiluvuri
/*****
**                       "PATENT PENDING"
** This code must be treated as an example pseudo code. This is
** just an example to teach the special methods of the CCG. This
** is intended for showing some new features. This code is not
** intended for use in any application (nor error free). However,
** useful to build example web pages to learn the patent methods
*****/

package com.agile.libtemplate;

import java.io.*;
import java.util.*;
import javax.servlet.http.HttpServletRequest;

public class RadioButtons extends AgileTemplate	{

	int count = 0;
	int first = 0;
	String buttons[] = null;
	String callback = null;

	// Constructor, which also initializes the Object.
	public RadioButtons(AC_Info aci, String list[], int num)	{
		super(aci);
		count = num;
		buttons = list;
	}
	public void setDefaultButton(int def)	{
			first = def;
	}

	// This Service Method of the Template returns,
	// The Service Method name of the Application Component:
	// For example, externel AC/CF code in the SVG-Doc includes the
	// following statement to call the service method of the AC:
	// Out.println(RadioCCG.getButtonSetMethodName + "(new_button);")
	public String getButtonSetMethodName()	{

		String name = "radio_" + UNQ_ID + ".select_new_button";
		return(name);
	}

	// The below function returns a service method name of the AC.
	// The Integration-logic uses this function to get the ACs
	// service method name. Then IL generates code, which contains
	// a call to the ACs service method to register a callback.
	// For Example, to register 'rb_callback', include JScript code:
	// Out.println(RadioCCG.getCB_AddMethodName + "('none', rb_callback);")
	public String getCB_AddMethodName()	{

		String name = "radio_" + UNQ_ID + ".add_callback";
		return(name);
	}

	//========================================================
	// Note: Either above or below method can be used to register a
	// callback. However, to conform to normal programing rules, that
	// is useing methods or variables only after defining them:
	// (a) the above method is used, if the CGM of the component
	// has been already called to include code for the AC and hence
	// the service method is already defined in the AC's code.
	// (b) the below method is used, if the CGM is not called and
	// AC code is not yet created, hence the CGM can include
	// necesary integration code in the code for the AC.

	// Hence it is possible to place parts of integration logic
	// anywhere (e.g. before or after calling the CGM of sub-ACs)
	// in the container CCG class code.
	//========================================================

	// The following function requests the CCG to register the JScript
	// function (whose name is given in the cb_name) as a callback
	// for the AC.
    //      This stores the name in a Java Class variable "callback"
    // If "callback != null" the CGM generates necessary code to
    // register the callback in the code for the AC.
	// For Example, to register 'rb_callback', include Java call:
	// RadioCCG.setCB_AddMethod ("rb_callback");
	public void setCB_AddMethod(String cb_name) {
			callback = cb_name;
	}

	// The Code Generation Method : CGM
	public int CGM (PrintWriter out) {

		// Code Check, if the CLASS definition is already in the Web document.
		if (this.aci.setJScriptClass("radio_buttons_v1_0") == false) { // Skip the class code

out.println("//SECTION-1:Copyright (C) All Rights reserved...Raju Chiluvuri ");
out.println("<script type='text/ecmascript'> ");
out.println("<![CDATA[ ");
out.println("function radio_buttons_v1_0(rb_list, first) ");
out.println("{ ");
out.println("    this.select_new_button = select_new_button; ");
out.println("    this.add_callback = add_callback; ");
out.println("    var current_button = first; ");
out.println("    var button_list = rb_list; ");
out.println("    var callback_func = null; ");
out.println("    var radio_group_id = 'GROUP_ID'; ");
out.println(" ");
out.println("    function add_callback( group_id, cb_name ) { ");
out.println("    		radio_group_id = group_id; ");
out.println("   		callback_func = cb_name; ");
out.println("    } ");
out.println("     ");
out.println("    function select_new_button(new_button) {  ");
out.println("	if(current_button != new_button) { ");
out.println("	    var svgobj = SVG_Document.getElementById(button_list[current_button]); ");
out.println("	    if (svgobj != null) ");
out.println("		(svgobj.getStyle()).setProperty ('visibility', 'hidden'); ");
out.println("	    svgobj = SVG_Document.getElementById(button_list[new_button]); ");
out.println("	    if (svgobj != null) ");
out.println("		(svgobj.getStyle()).setProperty ('visibility', 'visible'); ");
out.println(" ");
out.println("		current_button = new_button; ");
out.println("	    if (callback_func != null) 	 ");
out.println("			callback_func(radio_group_id, new_button); ");
out.println("	} ");
out.println("    } ");
out.println("} ");
out.println("]]> ");
out.println("</script> ");
out.println(" ");
				} // If statement to skip the JScript Class Defenition

out.println("// SECTION-2: Instantiation and Init section Radio-button Object ");
out.println("<script type='text/ecmascript'> ");
String	tmp_id = "rbutton_list_" + UNQ_ID;
out.print("var " + tmp_id + " = new Array(");
	for (int i = 0; i < count; i++) {
out.print("'rbutton" + i + "_" + UNQ_ID + "'");
		if(i < (count-1) )		out.print(",");
	}
out.println("); ");
out.println("var radio_" + UNQ_ID + " = new radio_buttons_v1_0(" + tmp_id + ", " + first + "); ");
out.println(" ");
	if (callback != null) {
out.println(" // Add code to call the callback. ");
out.println("radio_" + UNQ_ID + ".add_callback( 'none', " + callback + "); ");
	}
out.println(" ");
out.println("</script> ");
out.println(" ");

out.println("//SECTION-3: Presentation Section for the Rotate-Banner ");
out.println("<g> ");
	for (int i = 0; i < count; i++) {
	int y = i*20 + 5;
out.println("	<g transform='translate(5 " + y + ")' onclick='radio_" + UNQ_ID + ".select_new_button(" + i + ")'> ");
out.println("		<text x='20' y='20'> " + buttons[i] + " </text> ");
out.println("		<circle cx='10' cy='15' r='5' stroke-width='1' stroke='rgb(100,100,100)' fill='white'/> ");
out.println("		<circle cx='10' cy='15' r='3' id='rbutton" + i + "_" + UNQ_ID + "' ");
		if( first == i)
out.println("		style='fill:black;visibility:visible;'/> ");
		else
out.println("		style='fill:black;visibility:hidden;'/> ");
out.println("	</g> ");
		}
out.println("</g> ");
return 0;
	}	// END of the CGM()
}	// END of the Class Definition.