// Copyright(c) 2004 All Rights Reserved...Raju Chiluvuri
/*****
**                       "PATENT PENDING"
** This code must be treated as an example pseudo code. This is
** just an example to teach the special methods of the CCG. This
** is intended for showing some new features. This code is not
** intended for use in any application (nor error free). However,
** useful to build example web pages to learn the patent methods
*****/
package com.agile.libtemplate;

import java.io.*;
import java.util.*;
import javax.servlet.http.HttpServletRequest;

public class RadioButtons2	{
	public static int RadB = 1;
	int count = 0;
	int first = 0;
	String UNQ_ID = "rad" + RadB;
	String buttons[] = null;
	String callback = null;
	AC_Info	aci = null;

	// Constructor, which also initializes the Object.
	public RadioButtons2(AC_Info ACI, String list[], int num)	{
		count = num;
		buttons = list;
		aci = ACI;
	}
	public void setDefaultButton(int def)	{
			first = def;
	}

	// This Service Method of the Template returns,
	// The Service Method name of the Presentation-block.
	public String getButtonSetMethodName()	{
		String name = "radio_" + UNQ_ID + ".select_new_button";
		return(name);
	}
	// This Service Method of the Template (or CCG) returns,
	// The Service Method name of the Presentation-block.
	// The return method name may be used to register a Callback
	public String getCB_AddMethodName()	{

		String name = "radio_" + UNQ_ID + ".add_callback";
		return(name);
	}
	// Alternative method to set a Callback:
	// The container CCG picks a unique name for Callback.
	// Then it uses this methods to register the Callback.
	// This causes the CCG to add aditional code in the
	// code to register the Callback for the component.
	public void setCB_AddMethod(String cb_name) {
			callback = cb_name;
	}
	// Alternatively, the CCG could pick a unique name for the Callback.
	// This method returns the name of the Callback for the container-CCG
	public String getCallbackName() {
			callback = "radio_button_" + UNQ_ID + "_cb";
			return(callback);
	}

	public int CGM_Radio_section1 (PrintWriter out) {

		// Code Check, if the CLASS definition is already in the Web document.
		if (this.aci.setJScriptClass("radio_buttons_v1_0"))		return(0);

		out.println("//SECTION-1:Copyright (C) All Rights reserved...Raju Chiluvuri ");
		out.println("<script type='text/ecmascript'> ");
		out.println("<![CDATA[ ");
		out.println("function radio_buttons_v1_0(rb_list, first) ");
		out.println("{ ");
		out.println("    this.select_new_button = select_new_button; ");
		out.println("    this.add_callback = add_callback; ");
		out.println("    var current_button = first; ");
		out.println("    var button_list = rb_list; ");
		out.println("    var callback_func = null; ");
		out.println("    var radio_group_id = 'GROUP_ID'; ");
		out.println(" ");
		out.println("    function add_callback( group_id, cb_name ) { ");
		out.println("    		radio_group_id = group_id; ");
		out.println("   		callback_func = cb_name; ");
		out.println("    } ");
		out.println("     ");
		out.println("    function select_new_button(new_button) {  ");
		out.println("	if(current_button != new_button) { ");
		out.println("	    var svgobj = SVG_Document.getElementById(button_list[current_button]); ");
		out.println("	    if (svgobj != null) ");
		out.println("		(svgobj.getStyle()).setProperty ('visibility', 'hidden'); ");
		out.println("	    svgobj = SVG_Document.getElementById(button_list[new_button]); ");
		out.println("	    if (svgobj != null) ");
		out.println("		(svgobj.getStyle()).setProperty ('visibility', 'visible'); ");
		out.println(" ");
		out.println("		current_button = new_button; ");
		out.println("	    if (callback_func != null) 	 ");
		out.println("			callback_func(radio_group_id, new_button); ");
		out.println("	} ");
		out.println("    } ");
		out.println("} ");
		out.println("]]> ");
		out.println("</script> ");
		out.println(" ");
		return(0);
	}
	public int CGM_Radio_section2 (PrintWriter out) {
		out.println("// SECTION-2: Instantiation and Init section Radio-button Object ");
		out.println("<script type='text/ecmascript'> ");
		String	tmp_id = "rbutton_list_" + UNQ_ID;
		out.print("var " + tmp_id + " = new Array(");
			for (int i = 0; i < count; i++) {
		out.print("'rbutton" + i + "_" + UNQ_ID + "'");
				if(i < (count-1) )		out.print(",");
			}
		out.println("); ");
		out.println("var radio_" + UNQ_ID + " = new radio_buttons_v1_0(" + tmp_id + ", " + first + "); ");
		out.println(" ");
			if (callback != null) {
		out.println(" // Add code to call the callback. ");
		out.println("radio_" + UNQ_ID + ".add_callback( 'none', " + callback + "); ");
			}
		out.println(" ");
		out.println("</script> ");
		out.println(" ");
		return(0);
	}

	public int CGM_Radio_section3 (PrintWriter out) {
		out.println("//SECTION-3: Presentation Section for the Rotate-Banner ");
		out.println("<g> ");
			for (int i = 0; i < count; i++) {
			int y = i*20 + 5;
		out.println("	<g transform='translate(5 " + y + ")' onclick='radio_" + UNQ_ID + ".select_new_button(" + i + ")'> ");
		out.println("		<text x='20' y='20'> " + buttons[i] + " </text> ");
		out.println("		<circle cx='10' cy='15' r='5' stroke-width='1' stroke='rgb(100,100,100)' fill='white'/> ");
		out.println("		<circle cx='10' cy='15' r='3' id='rbutton" + i + "_" + UNQ_ID + "' ");
				if( first == i)
		out.println("		style='fill:black;visibility:visible;'/> ");
				else
		out.println("		style='fill:black;visibility:hidden;'/> ");
		out.println("	</g> ");
				}
		out.println("</g> ");
		return(0);
	}

	// The Code Generation Method : CGM
	public int CGM_Radio (PrintWriter out) {
			CGM_Radio_section1 (out);
			CGM_Radio_section2 (out);
			CGM_Radio_section3 (out);
		return 0;
	}	// END of the CGM()

}	// END of the Class Definition.