// Copyright(c) 2004 All Rights Reserved...Raju Chiluvuri
/*****
**                       "PATENT PENDING"
** This code must be treated as an example pseudo code. This is
** just an example to teach the special methods of the CCG. This
** is intended for showing some new features. This code is not
** intended for use in any application (nor error free). However,
** useful to build example web pages to learn the patent methods
*****/

package com.agile.libtemplate;

import java.io.*;
import java.util.*;
import javax.servlet.http.HttpServletRequest;

public class RotateBanner extends AgileTemplate	{

	int count = 0;
	Object banners[] = null;
	String	callback = null;
	String	Service_func = null;

	public	boolean	rotate_onclick = true;

	// Constructor, whic also initializes the Object.
	public RotateBanner(AC_Info ACI, Object list[], int num)	{
		super(ACI);
		count = num;
		banners = list;
	}

	// This Service Method of the CCG-Object returns,
	// The Service Method name of the Presentation-block.
	// For example, externel AC/CF code in the SVG-Doc includes the
	// following (i.e. JSP prints JScrip) code to get the AC's service:
	// <%=RB.getBannerUpdateMethodName()%>(new_banner)
	public String getBannerUpdateMethodName()	{
		String name = "rotate_obj_" + UNQ_ID + ".display_baner";
		return(name);
	}
    //========================================================
	// Note: Either above or below method can be used to determine
	// AC's servivce method. However, to conform to programing rules
	// that is: useing methods or variables only after defining them:
	// (a) the above method is used, if the CGM of the component
	// has been already called to include code for the AC and hence
	// the service method is already defined in the AC's code.
	// (b) the below method is used, if the CGM is not called and
	// AC code is not yet created, hence the CGM can include
	// necesary integration code in the code for the AC.
    //========================================================

	// Alternative method to get the reference to Service Method.
	// The Containe CCG could pass the name of a Variable (a pointer)
	// The CCG saves the name of the Variable in a Class variable.
	// If Service_func is not null, the CGM makes this INPUT
	// variable point to the Service Method of the Component
	//
	// Example, define a function pointer and call it in a Callback
	// 		var RB_service_func = function () {}; // An empty method
	//		var AC2_callback = function(par1, par2) {
	//				RB_service_func(par2, par1)
	//		}
	// CCG includes statement, to point it to real service method
	// 		RB_service_func = rotate_obj_UNQID.display_banner
	// Hence, AC2_callback calls real service method of AC1.
	public void setServiceMethodReference( String function_pointer)	{
		Service_func = function_pointer;
	}

	// The following function requests the CCG to register the JScript
	// function (whose name is given in the cb_name) as a callback
	// for the AC.
    // This stores the name in a Java Class variable "callback".
    // If "callback != null" the CGM generates necessary code to
    // register the callback in the code for the AC.
	public void setCallBackName( String cb_name)	{
		callback = cb_name;
	}
    //========================================================
	// Note: Either above or below method can be used to register a
	// callback. However, to conform to normal programing rules, that
	// is useing methods or variables only after defining them:
	// (a) the above method is used, if the CGM of the component
	// has been already called to include code for the AC and hence
	// the service method is already defined in the AC's code.
	// (b) the below method is used, if the CGM is not called and
	// AC code is not yet created, hence the CGM can include
	// necesary integration code in the code for the AC.

	// Hence it is possible to place parts of integration logic
	// anywhere (e.g. before or after calling the CGM of sub-ACs)
	// in the container CCG class code.
	//========================================================


	// The below function returns a service method name of the AC.
	// The Integration-logic uses this function to get the ACs
	// service method name. Then IL generates code, which contains
	// a call to the ACs service method to register a callback.
	public String getCB_AddMethodName()	{
		String name = "rotate_obj_" + UNQ_ID + ".add_callback";
		return(name);
	}

	private int generate_class_def(PrintWriter out) {

		// Code Check, if the CLASS definition is already in the Web document.
		if (this.aci.setJScriptClass("rotate_baner_v1_1"))		return(0);

		// Include the Class definition in the web document.
		out.println(" //SECTION-1: Class Declaration section of for the Rotate-Banner ");
		out.println("<script type='text/ecmascript'> ");
		out.println("<![CDATA[ ");
		out.println("function rotate_baner_v1_1(first) ");
		out.println("{ ");
		out.println("    this.add_baner = add_baner; ");
		out.println("    this.display_baner = display_baner; ");
		out.println("    this.add_callback = add_callback; ");
		out.println("    var current_baner = first;  ");
		out.println("    var callback_func = null; ");
		out.println("    var baner_lst = new Array();	 ");
		out.println("    function add_baner (baner_id) {    ");
		out.println("	baner_lst[baner_lst.length] = baner_id; ");
		out.println("    } ");
		out.println(" ");
		out.println("    function display_baner(new_baner) {  ");
		out.println("	if(current_baner != new_baner) { ");
		out.println("	    var svgobj = SVG_Document.getElementById(baner_lst[current_baner]); ");
		out.println("	    if (svgobj != null) ");
		out.println("			(svgobj.getStyle()).setProperty ('visibility', 'hidden'); ");
		out.println("	    svgobj = SVG_Document.getElementById(baner_lst[new_baner]); ");
		out.println("	    if (svgobj != null) ");
		out.println("			(svgobj.getStyle()).setProperty ('visibility', 'visible'); ");
		out.println("		current_baner = new_baner; ");
		out.println("	    if (callback_func != null) ");
		out.println("			callback_func(new_baner); ");
		out.println("	} ");
		out.println("    } ");
		out.println("    function add_callback( cb_name ) { ");
		out.println("   		callback_func = cb_name; ");
		out.println("    } ");
		out.println("} ");
		out.println("]]>");
		out.println("</script> ");
		out.println(" ");
		return(0);
	}
	private int generate_object_init(PrintWriter out) {
		out.println("// SECTION-2: Instantiation and Init section Rotate-Banner Object ");
		out.println(" ");
		out.println("<script type='text/ecmascript'> ");
		out.println("var rotate_obj_" + UNQ_ID + " = new rotate_baner_v1_1(0); ");

			for(int i = 0; i < count; i++) {	// Start of the For-loop
				int j = i + 1;
				out.println("rotate_obj_" + UNQ_ID + ".add_baner('banner_id" + j + "_"+ UNQ_ID+"'); ");
			}			// END of the For-loop

			// If "callback != null" generate code to register a callback
			if (callback != null) {
		out.println(" // Add code to call the callback. ");
		out.println("rotate_obj_" + UNQ_ID + ".add_callback(" + callback + "); ");
			}
			if (Service_func != null) {
		out.println(" // Add code to make the variable point to service-method. ");
		out.println(" " + Service_func + " = rotate_obj_" + UNQ_ID + ".display_baner");
			}
		out.println("</script> ");
		out.println(" ");
		return(0);
	}
	private int generate_svg_code(PrintWriter out) {
		out.println("//SECTION-3: Presentation Section for the Rotate-Banner ");
		out.println(" ");
		out.println("<g transform='translate(30 30)'> ");
		out.println("	<g id='contents'>  </g><!-- contents --> ");

				for(int i = 0; i < count; i++) {  // Start of the For-loop
					int	j = i + 1;
					if(j==1)
		out.println("<g id='banner_id"+ j + "_"+ UNQ_ID +"' style='visibility:visible;'  ");
				else{
		out.println("<g id='banner_id"+ j + "_"+ UNQ_ID +"' style='visibility:hidden;'  ");
					}

				if(rotate_onclick) {
					if( j >= count)		j = 0;
					out.println("		onclick='rotate_obj_" + UNQ_ID + ".display_baner(" + j + ")'> ");
				}
				else
					out.println(" > ");

					GenerateComponentCode(banners[i], out);
					//	The above function conprises of (and repleces) the following code:
					//	if(layers[i] instanceof AgileTemplate)
					//		((AgileTemplate)layers[i]).CGM(out, doc_info);
					//	else
					//		out.print(layers[i]);
		out.println("</g>  ");
				}			// END of the For-loop
		out.println("</g> ");
		return(0);
	}

	// The Code Generation Method : CGM
	public int CGM (PrintWriter out) {

		generate_class_def(out);
		generate_object_init(out);
		generate_svg_code (out);

		return 0;
	}	// END of the CGM()
}	// END of the Class Definition.