// Copyright(c) 2004 All Rights Reserved...Raju Chiluvuri
/*****
**                       "PATENT PENDING"
** This code must be treated as an example pseudo code. This is
** just an example to teach the special methods of the CCG. This
** is intended for showing some new features. This code is not
** intended for use in any application (nor error free). However,
** useful to build example web pages to learn the patent methods
*****/
package com.agile.libtemplate;

import java.io.*;
import java.util.*;
import javax.servlet.http.HttpServletRequest;

public class RotateBanner2	{
	public static int RbCount = 1;
	int count = 0;
	String UNQ_ID = "rb" + RbCount++;
	Object banners[] = null;
	String	callback = null;
	String	ServiceMethod1 = null;
	AC_Info	aci;

	// Constructor, whic also initializes the Object.
	public RotateBanner2(AC_Info ACI, Object list[], int num)	{
		aci = ACI;
		count = num;
		banners = list;
	}

	// This Service Method of the Template returns,
	// The Service Method name of the Presentation-block.
	public String getBannerUpdateMethodName()	{

		String name = "rotate_obj_" + UNQ_ID + ".display_baner";
		return(name);
	}
	// Prefered embodyment gets the service method name and call the
	// service method from a Callback to get the component's service.
	//
	// Some times, it may be useful to know the name of the service
	// method even befor the CCG is created. Other times, same
	// function may need to call service methods of different
	// components. This can be accomplished as follows:
	//
	/*	Pick a unique name (e.g. dynamic_service_selection) for the
		function pointer variable,then generate following code using
		the name and include the code in the integration code. */
	/*
		var dynamic_service_selection = function() { };
	*/
	/*	Now, the variable "dynamic_service_selection" may be
		pointed to any function. Calling dynamic_service_selection()
		is same as calling the function that it is assigned to. */
	//
	// The following service method allows to set a name for the
	// service method of the component. It sets object-variable
	// ServiceMethod1. If the ServiceMethod1 is not null,
	// the CGM adds code to assign the conponent's service
	// method to the JavaScript variable.
	public void setBannerUpdateMethodName(String sm_name)	{
			ServiceMethod1 = sm_name;
	}
	public String getCB_AddMethodName()	{

		String name = "rotate_obj_" + UNQ_ID + ".add_callback";
		return(name);
	}
	public void setCallBackName( String cb_name)	{
		callback = cb_name;
	}

	public int generate_class_def (PrintWriter out) {
		out.println(" //SECTION-1: Class Declaration section of for the Rotate-Banner ");

		out.println("<script type='text/ecmascript'> ");
		out.println("<![CDATA[ ");
		out.println("function rotate_baner_v1_1(first) ");
		out.println("{ ");
		out.println("    this.add_baner = add_baner; ");
		out.println("    this.display_baner = display_baner; ");
		out.println("    this.add_callback = add_callback; ");
		out.println("    var current_baner = first;  ");
		out.println("    var callback_func = null; ");
		out.println("    var baner_lst = new Array();	 ");
		out.println("    function add_baner (baner_id) {    ");
		out.println("	baner_lst[baner_lst.length] = baner_id; ");
		out.println("    } ");
		out.println(" ");
		out.println("    function display_baner(new_baner) {  ");
		out.println("	if(current_baner != new_baner) { ");
		out.println("	    var svgobj = SVG_Document.getElementById(baner_lst[current_baner]); ");
		out.println("	    if (svgobj != null) ");
		out.println("			(svgobj.getStyle()).setProperty ('visibility', 'hidden'); ");
		out.println("	    svgobj = SVG_Document.getElementById(baner_lst[new_baner]); ");
		out.println("	    if (svgobj != null) ");
		out.println("			(svgobj.getStyle()).setProperty ('visibility', 'visible'); ");
		out.println("		current_baner = new_baner; ");
		out.println("	    if (callback_func != null) ");
		out.println("			callback_func(new_baner); ");
		out.println("	} ");
		out.println("    } ");
		out.println("    function add_callback( cb_name ) { ");
		out.println("   		callback_func = cb_name; ");
		out.println("    } ");
		out.println("} ");
		out.println("]]>");
		out.println("</script> ");
		out.println(" ");
		return(0);
	}

	public int generate_class_inst (PrintWriter out) {
		out.println("// SECTION-2: Instantiation and Init section Rotate-Banner Object ");
		out.println(" ");
		out.println("<script type='text/ecmascript'> ");
		out.println("var rotate_obj_" + UNQ_ID + " = new rotate_baner_v1_1(0); ");

			for(int i = 0; i < count; i++) {	// Start of the For-loop
				int j = i + 1;
				out.println("rotate_obj_" + UNQ_ID + ".add_baner('banner_id" + j + "_"+ UNQ_ID+"'); ");
			}			// END of the For-loop
			// If not null, generate code to register the Callback
			if (callback != null) {
		out.println(" // Add code to call the callback. ");
		out.println("rotate_obj_" + UNQ_ID + ".add_callback(" + callback + "); ");
			}
			// If not null, generate code to point the variable to service method.
			if (ServiceMethod1 != null) {
		out.println(" // Set the given Variable to point to the service method. ");
		out.println(ServiceMethod1 + " = rotate_obj_" + UNQ_ID + ".display_baner");
			}
		out.println("</script> ");
		out.println(" ");
		return(0);
	}
	public int generate_svg_code (PrintWriter out) {
		out.println("//SECTION-3: Presentation Section for the Rotate-Banner ");
		out.println(" ");
		out.println("<g transform='translate(30 30)'> ");
		out.println("	<g id='contents'>  </g><!-- contents --> ");

				for(int i = 0; i < count; i++) {  // Start of the For-loop
					int	j = i + 1;
					if(j==1)
		out.println("<g id='banner_id"+ j + "_"+ UNQ_ID +"' style='visibility:visible;'  ");
				else{
		out.println("<g id='banner_id"+ j + "_"+ UNQ_ID +"' style='visibility:hidden;'  ");
					}


				if( j >= count)		j = 0;
		out.println("		onclick='rotate_obj_" + UNQ_ID + ".display_baner(" + j + ")'> ");
					if(banners[i] instanceof AgileTemplate)
						((AgileTemplate)banners[i]).CGM(out);
					else
						out.print(banners[i]);
		out.println("</g>  ");
				}			// END of the For-loop
		out.println("</g> ");

		return(0);
	}

	// The Code Generation Method : CGM
	public int CGM_Rotate (PrintWriter out) {
		generate_class_def(out);
		generate_class_inst(out);
		generate_svg_code (out);
		return 0;
	}	// END of the CGM()
}	// END of the Class Definition.