// Copyright(c) 2004 All Rights Reserved...Raju Chiluvuri
/*****
**                       "PATENT PENDING"
** This code must be treated as an example pseudo code. This is
** just an example to teach the special methods of the CCG. This
** is intended for showing some new features. This code is not
** intended for use in any application (nor error free). However,
** useful to build example web pages to learn the patent methods
*****/

package com.agile.libtemplate;

import java.io.*;
import java.util.*;
import javax.servlet.http.HttpServletRequest;

public class RotateBanner3 extends AgileTemplate	{

	int count = 0;
	Object banners[] = null;
	String	callback = null;
	String	Service_func = null;

	// Constructor, whic also initializes the Object.
	public RotateBanner3(AC_Info ACI, Object list[], int num)	{
		super(ACI);
		count = num;
		banners = list;
	}

	// This Service Method of the CCG-Object returns,
	// The Service Method name of the Presentation-block.
	public String getBannerUpdateMethodName()	{

		String name = "rotate_obj_" + UNQ_ID + ".display_baner";
		return(name);
	}
	// Alternative method to get the reference to Service Method.
	// The Containr could pass the name of a Variable.
	// The CCG saves the name of the Variable in a Class variable.
	// If Service_func is not null, the CGM makes this INPUT
	// variable point to the Service Method of the Component
	public void setServiceMethodReference( String function_pointer)	{
		Service_func = function_pointer;
	}
	public void setCallBackName( String cb_name)	{
		callback = cb_name;
	}
	public String getCB_AddMethodName()	{
		String name = "rotate_obj_" + UNQ_ID + ".add_callback";
		return(name);
	}


	private int generate_class_def(PrintWriter out) {

		// Code Check, if the CLASS definition is already in the Web document.
		if (this.aci.setJScriptClass("rotate_baner_v1_1"))		return(0);

		// Include the Class definition in the web document.
		out.println(" //SECTION-1: Class Declaration section of for the Rotate-Banner ");
		out.println("<script type='text/ecmascript'> ");
		out.println("<![CDATA[ ");
		out.println("function rotate_baner_v1_1(first) ");
		out.println("{ ");
		out.println("    this.add_baner = add_baner; ");
		out.println("    this.display_baner = display_baner; ");
		out.println("    this.add_callback = add_callback; ");
		out.println("    var current_baner = first;  ");
		out.println("    var callback_func = null; ");
		out.println("    var baner_lst = new Array();	 ");
		out.println("    function add_baner (baner_id) {    ");
		out.println("	baner_lst[baner_lst.length] = baner_id; ");
		out.println("    } ");
		out.println(" ");
		out.println("    function display_baner(new_baner) {  ");
		out.println("	if(current_baner != new_baner) { ");
		out.println("	    var svgobj = SVG_Document.getElementById(baner_lst[current_baner]); ");
		out.println("	    if (svgobj != null) ");
		out.println("			(svgobj.getStyle()).setProperty ('visibility', 'hidden'); ");
		out.println("	    svgobj = SVG_Document.getElementById(baner_lst[new_baner]); ");
		out.println("	    if (svgobj != null) ");
		out.println("			(svgobj.getStyle()).setProperty ('visibility', 'visible'); ");
		out.println("		current_baner = new_baner; ");
		out.println("	    if (callback_func != null) ");
		out.println("			callback_func(new_baner); ");
		out.println("	} ");
		out.println("    } ");
		out.println("    function add_callback( cb_name ) { ");
		out.println("   		callback_func = cb_name; ");
		out.println("    } ");
		out.println("} ");
		out.println("]]>");
		out.println("</script> ");
		out.println(" ");
		return(0);
	}
	private int generate_object_init(PrintWriter out) {
		out.println("// SECTION-2: Instantiation and Init section Rotate-Banner Object ");
		out.println(" ");
		out.println("<script type='text/ecmascript'> ");
		out.println("var rotate_obj_" + UNQ_ID + " = new rotate_baner_v1_1(0); ");

			for(int i = 0; i < count; i++) {	// Start of the For-loop
				int j = i + 1;
				out.println("rotate_obj_" + UNQ_ID + ".add_baner('banner_id" + j + "_"+ UNQ_ID+"'); ");
			}			// END of the For-loop

			if (callback != null) {
		out.println(" // Add code to call the callback. ");
		out.println("rotate_obj_" + UNQ_ID + ".add_callback(" + callback + "); ");
			}
			if (Service_func != null) {
		out.println(" // Add code to make the variable point to service-method. ");
		out.println(" " + Service_func + " = rotate_obj_" + UNQ_ID + ".display_baner");
			}
		out.println("</script> ");
		out.println(" ");
		return(0);
	}
	private int generate_svg_code(PrintWriter out) {
		out.println("//SECTION-3: Presentation Section for the Rotate-Banner ");
		out.println(" ");
		out.println("<g transform='translate(3 3)'> ");
		out.println("	<g id='contents'>  </g><!-- contents --> ");

				for(int i = 0; i < count; i++) {  // Start of the For-loop
					int	j = i + 1;
					if(j==1)
		out.println("<g id='banner_id"+ j + "_"+ UNQ_ID +"' style='visibility:visible;' > ");
				else{
		out.println("<g id='banner_id"+ j + "_"+ UNQ_ID +"' style='visibility:hidden;' > ");
					}


				if( j >= count)		j = 0;
					GenerateComponentCode(banners[i], out);
					//	The above function conprises of (and repleces) the following code:
					//	if(layers[i] instanceof AgileTemplate)
					//		((AgileTemplate)layers[i]).CGM(out, doc_info);
					//	else
					//		out.print(layers[i]);
		out.println("</g>  ");
				}			// END of the For-loop
		out.println("</g> ");
		return(0);
	}

	// The Code Generation Method : CGM
	public int CGM (PrintWriter out) {

		generate_class_def(out);
		generate_object_init(out);
		generate_svg_code (out);

		return 0;
	}	// END of the CGM()
}	// END of the Class Definition.