// Copyright(c) 2004 All Rights Reserved...Raju Chiluvuri
/*****
**                       "PATENT PENDING"
** This code must be treated as an example pseudo code. This is
** just an example to teach the special methods of the CCG. This
** is intended for showing some new features. This code is not
** intended for use in any application (nor error free). However,
** useful to build example web pages to learn the patent methods
*****/
package com.agile.libtemplate;

import java.io.*;
import java.util.*;
import javax.servlet.http.HttpServletRequest;

public class ShowLayer extends AgileTemplate	{

	int 	count = 0;
	Object	layers[] = null;
	String	callback = null;

	// Constructor, whic also initializes the Object.
	public ShowLayer(AC_Info ACI, Object list[], int num)
	{
		super(ACI);
		count = num;
		layers = list;
	}

	// This Service Method of the Template returns,
	// The Service Method name of the Presentation-block.
	public String getShowLayerName()	{

		String name = "layer_obj_" + UNQ_ID + ".show_layer";
		return(name);
	}
	public String getSwitchStateName()	{

		String name = "layer_obj_" + UNQ_ID + ".switch_state";
		return(name);
	}
	public String getCallbackMethodName()	{
		String name = "layer_obj_" + UNQ_ID + ".add_callback";
		return(name);
	}
	// Alternative method to register a Callback, whose name is INPUT.
	// In this case, the CCG adds code to set the Callback
	public void setCallBackName( String cb_name)	{
		callback = cb_name;
	}
	// Alternative method to register a Callback:
	// In this case, the CCG picks a unique name for the Callback
	// It uses the name to set the Callback, and returns the name.
	public String getCallBackName()	{
		callback = "layer_obj_" + UNQ_ID + "_cb";
		return(callback);
	}
	// The Code Generation Method for Section-1 of CGM
private int generate_class_def (PrintWriter out) {
out.println("//** SECTION-1 of the Presentation-Block code for the Show-Layers:: ");
out.println("<script type='text/ecmascript'> ");
out.println("<![CDATA[ ");
out.println("/* ");
out.println("COMPONENT_INTEGRATION_DATA     SHOW_LAYER { ");
out.println("	UNIQUE_INDEX_NUMBER	=	" + UNQ_ID + " ");
out.println("	OBJECT_INSTENCE_NAME	=	layer_obj_" + UNQ_ID + " ");
out.println("	ADD_SWITCH_CALLBACK	=	add_callback ");
out.println("	SHOW_LAYER_SERVICE	=	show_layer ");
out.println("	SWITCH_STATE_SERVICE	=	switch_state ");
out.println("} */ ");
out.println(" ");
out.println("]]> ");
out.println("</script> ");

		// Code Check, if the CLASS definition is already in the Web document.
		if (this.aci.setJScriptClass("show_layers_v1_0"))		return(0);

out.println("<script type='text/ecmascript'> ");
out.println("<![CDATA[ ");
out.println("function show_layers_v1_0(id_lst, layer_id) ");
out.println("{ ");
out.println("    this.show_layer = show_layer; ");
out.println("    this.switch_state = switch_state; ");
out.println("    this.add_callback = add_callback; ");
out.println("    this.layer_init = layer_init; ");
out.println("    var layer_states = new Array(); ");
out.println("    var callback_func = null; ");
out.println("    var layer_lst = id_lst; ");
out.println("    var def_layer = layer_id; ");
out.println("    var layer_node = new Array(); ");
out.println(" ");
out.println("    function show_layer(lid, stat) { ");
out.println("	if(layer_states[lid] != stat) { ");
out.println("	   (layer_node[lid].getStyle()).setProperty('visibility',stat); ");
out.println("			layer_states[lid] = stat; ");
out.println("	    if (callback_func != null) ");
out.println("			callback_func(lid+1, layer_lst[lid], stat); ");
out.println("	} ");
out.println("    } ");
out.println("    function add_callback( cb_name ) { ");
out.println("   		callback_func = cb_name; ");
out.println("    } ");
out.println("    function switch_state(lid) { ");
out.println("      show_layer(lid,(layer_states[lid]=='hidden')?'visible':'hidden'); ");
out.println("    } ");
out.println("    function layer_init(e) { ");
out.println("	if(layer_node.length == 0) { ");
out.println("	var SVGDoc = e.getTarget().getOwnerDocument(); ");
out.println("	    for ( i = 0; i < layer_lst.length; i++) { ");
out.println("      		layer_node[i] = SVGDoc.getElementById(layer_lst[i]); ");
out.println("      		layer_states[i] = 'hidden'; ");
out.println("      	    } ");
out.println("	} ");
out.println("	if(def_layer >= 0)	show_layer(def_layer, 'visible'); ");
out.println("    } ");
out.println("} ");
out.println("]]> ");
out.println("</script> ");
return 0;
	}// END of the generate_class_def()

private int generate_object_init (PrintWriter out) {
out.println(" ");
out.println("// SECTION-2 of the Presentation-Block code for the Show-Layers:: ");
out.println(" ");
out.println("<script type='text/ecmascript'> ");
out.print("var layer_ids_" + UNQ_ID + " = new Array( ");

	for(int i = 0; i < count; i++) {  // Start of the For-loop
		int j = i + 1;
		if (j < count)
			out.print("'layer_id" + j + "_" + UNQ_ID + "', ");
		else
			out.println("'layer_id" + j + "_" + UNQ_ID + "'); ");
	}		// END of the For-loop

out.println(" ");
out.println("var layer_obj_" + UNQ_ID + " = new show_layers_v1_0(layer_ids_" + UNQ_ID + ", 0); ");
out.println("onload_init_list[onload_init_list.length]=layer_obj_" + UNQ_ID + ".layer_init; ");

	if (callback != null) {
out.println(" // Add code to call the callback. ");
out.println("layer_obj_" + UNQ_ID + ".add_callback(" + callback + "); ");
	}
return 0;
	}// END of the generate_object_init()

private int generate_svg_code (PrintWriter out) {
out.println("</script> ");
out.println(" ");
out.println("// SECTION-3 of the Presentation-Block code for the Show-Layers: ");
out.println(" ");
out.println("<g transform='translate(30 30)'> ");
out.println("    <g id='contents'>    </g><!-- contents --> ");
out.println(" ");

	for(int i = 0; i < count; i++) {  // Start of the For-loop
		int j = i + 1;

out.println(" <g id='layer_id" + j + "_" + UNQ_ID + "' style='visibility:hidden;'> ");
		if( j >= count)		j = 0;

		if(layers[i] instanceof AgileTemplate)
				((AgileTemplate)layers[i]).CGM(out);
		else
				out.print(layers[i]);
		// The above "if-else" statement may be replaced by following function:
		// GenerateComponentCode(layers[i], out, doc_info);
out.println("</g>  ");

	}			// END of the For-loop

out.println("</g> ");
return 0;
	}// END of the generate_svg_code()

	// The Code Generation Method : CGM
	public int CGM (PrintWriter out) {
		generate_class_def(out);
		generate_object_init(out);
		generate_svg_code (out);
		return 0;
	}	// END of the CGM()

}// END of the Class Definition.