/*****
* #ident "%Z%%Y% %M% %I%     %E%
*
* Last Modified %D%
* Module : UniqStrId.java
*
* Copyright(c) 2005		Pioneer-soft LLC	All Rights Reserved.
*
*                       "PATENT PENDING"
* This software code is the proprietary of Pioneer-soft, LLC
* You shall use it only in accordance with the terms of the
* license agreement you entered with Pionner-soft, LLC.
*
* Terms Of Use:
* =============
*       This Class code is Open for inspection and may be used
*       only for learning the technology or for educational
*       purpose for limited time, no more than 6 weeks.
*
*       One must obtain a valid licence "Key" and an agreement
*       from Pioneer-soft LLC to use this Code or to build any
*       software based on the "patent-pending" technologies.
*
*
* Description:	A General Utility to generate Unique string
*				This gets next unique string, that is formed
*				62 alphabits and numbers.
*				<> This string is appended to each identifier
*				of the AC to avoid identifier name colision.
*
* Version	:	1.0
*
* History	:	9-9-2005	Raju Chiluvuri		Created New.
*****/
package com.agile.libtemplate;

import java.io.*;
import java.util.*;
import javax.servlet.http.HttpServletRequest;

public class UniqStrId {
	final		static	char	char_list[] = {'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z',
										'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y',
										'1','2','3','4','5','6','7','8','9','0','z'};
	final		static	short		MAX_LENGTH 	= 12;
	final		static	short		MAX_CHARS	= 62;
	short		str_length= 0;
	short		char_idx = -1;
	char		cur_str[] = new char[MAX_LENGTH];
	short		char_idx_lst[] = new short[MAX_LENGTH];

public void reset_counters() {
		str_length= 0;
		char_idx = -1;
		char_idx_lst[0] = 0;
}

/* This function starts with 'A' and uses 62 digits. It increments
** each time to get next number of 62 digit-based numbering system.*/
public String get_uniq_idx() {

		if(++char_idx < MAX_CHARS) {
			cur_str[str_length] = char_list[char_idx];
			return(new String(cur_str,0,str_length+1));
		}

		char_idx = char_idx_lst[str_length] = 0;
		cur_str[str_length] = char_list[0];
		int	i = str_length;
		while (--i >= 0) {
			if (++char_idx_lst[i] < MAX_CHARS) {
				cur_str[i] = char_list[char_idx_lst[i]];
				return(new String(cur_str,0,str_length+1));
			}
			char_idx_lst[i] = 0;
			cur_str[i] = char_list[0];
		}
		char_idx_lst[++str_length] = 0;
		cur_str[str_length] = char_list[char_idx];
		return(new String(cur_str,0,str_length+1));
	}
}	// END of the Class Definition.